#include <iostream>
#include <LiDIA/bigint.h>
#include <LiDIA/galois_field.h>
#include <LiDIA/gf_element.h>
#include <LiDIA/base_vector.h>
#include <LiDIA/polynomial.h>
#include <LiDIA/Fp_polynomial.h>
#include <LiDIA/factorization.h>
#include <LiDIA/elliptic_curve.h>
#include <LiDIA/point.h>
#include "LiDIA/gf_polynomial.h"
#include <time.h>

using namespace std;
using namespace LiDIA;


// Declaracion de vbles globales

bigint chi1,p,p1;
bigint c1;
gf_element c;
gf_element c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15;
gf_element c16,c17,c18,c19,c20,c21,c22,c23,c24,c25;

Fp_polynomial f , fz;
bool congr; // variable per indicar nomes si hi ha congruencia.

bigint Div7_(bigint p1,bigint c1)
{
       
	bigint p;
	p=p1;
	galois_field Fp( p );
	bigint c;
	c=c1;
	bigint size7div;  //per mirar si tenim  3  o 24 solucions
        gf_element a1( Fp ),
                   a2( Fp ),
                   a3( Fp ),
                   a4( Fp ),
                   a6( Fp );

		a1 = 1+c-(c*c);
        a2 = (c*c)*(1-c);
        a3 = a2;
        a4 = 0;
        a6 = 0;
        elliptic_curve< gf_element > E( a1, a2, a3, a4, a6 );
        gf_element b2, b4, b6, b8;
        E.get_bi( b2, b4, b6, b8 );
        bigint d2( b2.lift_to_Z( ) );
        bigint d4( b4.lift_to_Z( ) );
        bigint d6( b6.lift_to_Z( ) );
        bigint d8( b8.lift_to_Z( ) );
        
        Fp_polynomial f;
	f.set_modulus( p );
        f[ 0 ] = d4 * d8 - d6 * d6;
        f[ 1 ] = d2 * d8 - d4 * d6;
        f[ 2 ] = 10 * d8;
        f[ 3 ] = 10 * d6;
        f[ 4 ] = 5 * d4;
        f[ 5 ] = d2;
        f[ 6 ] = 2;
        Fp_polynomial g;
        g.set_modulus( p );
        g[ 0 ] = d6;
        g[ 1 ] = 2 * d4;
        g[ 2 ] = d2;
        g[ 3 ] = 4;
        Fp_polynomial h;
	h.set_modulus( p );
        h[ 0 ] = d8;
        h[ 1 ] = 3 * d6;
        h[ 2 ] = 3 * d4;
        h[ 3 ] = d2;
        h[ 4 ] = 3;
        h = h * h * h;
        f = f * g * g * ( h - f * f ) - h * h;
        	
	base_vector<bigint> bv;
	bv=find_roots(f);
	cout<<"ARRELS del polinomi de 7 divisio----"<<bv<<endl;
	size7div=bv.size();

	if(size7div==24)  // si veiem que te 24 arrels farem el proces per trobar el punt
		{
			bigint puntx;
			bigint punt2x;
			bigint punt3x;
			bigint puntxdif;
			int cont=0;
			gf_element chin;
			chin.assign_zero(Fp);
			point < gf_element > punt(E);
			punt.set_x_coordinate(chin);
			//cout<<"probando despues eliminar"<<punt<<endl;
			puntx=punt.get_x().lift_to_Z();
			//cout<<puntx<<endl;
			punt2x=punt.twice().get_x().lift_to_Z();
			//cout<<punt2x<<endl;
			punt3x=(punt.twice()+punt).get_x().lift_to_Z();
			//cout<<punt3x<<endl;
	
				while(bv[cont]==puntx || bv[cont]==punt2x || bv[cont]==punt3x)
					{
						cont++;
					}
	
					puntxdif=bv[cont];
					cout<<puntxdif<<endl;		
				return puntxdif;
		}
		else{
			cout<<"ARRELS del polinomi de 7 divisio----"<<bv<<endl;
			return -1;
			
		    } // si per el contrari no te 24 arrels sino que te 3 no cal fer res mes
	
}

void polchi (const gf_element & chi)
{
		
    

	f[ 0 ] = ( c25 + c24*chi + 10*c24 - 22*c23*chi - 1308*c23 + 159*c22*chi + 27314*c22 - 20*c21*chi -
              284089*c21 - 6363*c20*chi + 1776838*c20 + 38710*c19*chi - 7218071*c19 - 69153*c18*chi +
              19803153*c18 - 303682*c17*chi - 37510728*c17 + 2313123*c16*chi + 49810389*c16 -
              7303966*c15*chi - 47205305*c15 + 13901159*c14*chi + 33062403*c14 - 16924180*c13*chi -
              18263028*c13 + 12983481*c12*chi + 8521030*c12 - 5839092*c11*chi - 3397781*c11 + 
              1258192*c10*chi + 1155715*c10 + 4594*c9*chi - 336072*c9 - 84577*c8*chi + 62482*c8 +
              38092*c7*chi - 4666*c7 - 8596*c6*chi + 1092*c6 + 2058*c5*chi + 560*c5 + 91*c4*chi + 64*c4 -
              34*c3*chi - 4*c3 + 27*c2*chi + c2 - 2*c*chi + chi ).lift_to_Z( );
    f[ 1 ] = ( - 21*c21 - 14*c20*chi + 651*c20 + 280*c19*chi - 7133*c19 - 1904*c18*chi + 22176*c18 +
              2156*c17*chi + 153545*c17 + 40026*c16*chi - 1613164*c16 - 249312*c15*chi + 6338395*c15 +
              645106*c14*chi - 13787480*c14 - 600698*c13*chi + 18231374*c13 - 852852*c12*chi - 15347997*c12 +
              2967860*c11*chi + 8828575*c11 - 3218320*c10*chi - 4043186*c10 + 1373344*c9*chi + 1616384*c9 +
              22736*c8*chi - 463393*c8 - 151424*c7*chi + 88907*c7 + 42378*c6*chi - 15995*c6 - 18578*c5*chi -
              1547*c5 - 168*c4*chi - 112*c4 - 294*c3*chi + 35*c3 - 322*c2*chi - 14*c2 - 14*chi ).lift_to_Z( );
    f[ 2 ] = ( - 7*c17 + 77*c16*chi + 168*c16 - 1344*c15*chi + 210*c15 + 8043*c14*chi + 8785*c14 -
              12544*c13*chi - 184072*c13 - 66542*c12*chi + 966378*c12 + 356916*c11*chi - 2261840*c11 -
              691096*c10*chi + 2753366*c10 + 562240*c9*chi - 1849743*c9 - 72261*c8*chi + 759822*c8 -
              64652*c7*chi - 259868*c7 - 71393*c6*chi + 69867*c6 + 45276*c5*chi - 4361*c5 + 2107*c4*chi +
              1176*c4 + 3528*c3*chi + 42*c3 + 1533*c2*chi + 77*c2 + 112*c*chi + 77*chi ).lift_to_Z( );
    f[ 3 ] = ( 14*c14 - 420*c13 - 210*c12*chi + 2709*c12 + 2996*c11*chi - 7574*c11 - 14084*c10*chi - 
              1148*c10 + 18480*c9*chi + 82320*c9 + 37492*c8*chi - 201488*c8 - 120596*c7*chi + 190246*c7 +
              88200*c6*chi - 75320*c6 - 1596*c5*chi + 15904*c5 + 210*c4*chi - 5005*c4 - 7196*c3*chi - 42*c3 -
              3220*c2*chi - 196*c2 - 476*c*chi - 210*chi ).lift_to_Z( );
    f[ 4 ] = ( 28*c10 + 182*c9 + 294*c8*chi - 1561*c8 - 3038*c7*chi + 3024*c7 + 8869*c6*chi + 2380*c6 -
              4312*c5*chi - 8631*c5 - 7056*c4*chi + 4571*c4 + 1862*c3*chi - 315*c3 + 2695*c2*chi + 322*c2 +
              686*c*chi + 294*chi ).lift_to_Z( );
    f[ 5 ] = ( - 7*c7 + 21*c6 - 161*c5 - 196*c4*chi + 280*c4 + 1078*c3*chi + 84*c3 - 588*c2*chi - 224*c2 -
              294*c*chi + 7*c - 196*chi ).lift_to_Z( );
    f[ 6 ] = ( 49*chi ).lift_to_Z( );
    f[ 7 ] = 1;

    


}

void polfz (const gf_element & z)
{


fz[ 0 ] = ( c16 - 6*c15 + 15*c14 - 20*c13 + 15*c12 - 6*c11 + c10 ).lift_to_Z( );
fz[ 1 ] = ( c15 - 8*c14 + 22*c13 - 25*c12 + 5*c11 + 14*c10 - 12*c9 + 3*c8 ).lift_to_Z( );
fz[ 2 ] = ( - c13 + 6*c12 - 8*c11 + c10*z - 5*c10 - 4*c9*z + 
          15*c9 + 6*c8*z - 4*c8 - 4*c7*z - 6*c7 + c6*z + 3*c6 ).lift_to_Z( );
fz[ 3 ] = ( c12 - 6*c11 + 12*c10 - 14*c9 - 2*c8*z + 12*c8 + 
          4*c7*z - 4*c7 - 2*c6 - 4*c5*z + 2*c4*z + c4 ).lift_to_Z( );
fz[ 4 ] = ( - 4*c9 + 25*c8 - 50*c7 + c6*z + 46*c6 + 2*c5*z - 
          23*c5 - 6*c4*z + 7*c4 + 2*c3*z - c3 + c2*z ).lift_to_Z( );
fz[ 5 ] = ( c7 - 3*c6 - 5*c5 + 16*c4 - 2*c3*z - 12*c3 + 4*c2 + 2*c*z - c ).lift_to_Z( );
fz[ 6 ] = ( z ).lift_to_Z( );
fz[ 7 ] = 1;



}



void baixar (gf_element & chi, bigint & niv)
{

gf_element aux( chi.get_field( ) );
lidia_size_t sz1,sz2,i;
bool b;
base_vector< bigint > bv , bv2;


do {
b=false;
i=-1;

polchi(chi);
bv=find_roots(f);
sz1 = bv.size( ) - 1;

while(b==false && i<sz1)
{
i++;
aux = bv[ i ];
polfz( aux );

bv2=find_roots(fz);
sz2=bv2.size();

if(sz2!=0){
b=true;
}
}
if(b==true)
{
niv = niv + 1;
chi=bv2[1];
}

}while(b);
}


void sylow(const bigint & ps,const gf_element & cs,bigint & n,point<gf_element> & P,bigint & r, point <gf_element> & Q)
{

// Declaracio de Vbles

p=ps;
bigint segchi=0;                 // variable que retorna la funció 7 divisió.
bool vqsol;
galois_field F = cs.get_field(); 
c=cs;

// Final de declaració de Vbles

// Comprovació de congruència // hem de pasar la c a bigint per poder cridar a 7 div
gf_element c2d;
c2d=cs;
bigint c3d;
c3d=c2d.lift_to_Z( );

if((p%7)==1) // CONGRUENT (OK)
{
	cout<<"cas congruent"<<endl;	
	segchi=Div7_(p,c3d);
	if(segchi!=-1){vqsol=true;cout<<"cas no ciclic"<<endl;}
	else{vqsol=false;cout<<"cas ciclic"<<endl;}
}
else if((p%7)!=1){cout<<"Cas no congruent"<<endl;vqsol=false;} // NO CONGRUENT (OK)

// Comprovació de discriminant

galois_field g1(p);
gf_element discr;
discr.assign_zero(g1);
discr=1+5*c-8*(c*c)+(c*c*c);
if(discr==0){cout<<"El discriminant es 0 i no podem seguir"<<endl;}  //el discriminant es 0 parem
else            //el discriminant no es 0 seguim INICI (OK)
{

//--------------Inici dels powers
	power(c2,c,2);
	power(c3,c,3);
	power(c4,c2,2);
	power(c5,c,5);
	power(c6,c2,3);
	power(c7,c,7);
	power(c8,c2,4);
	power(c9,c3,3);
	power(c10,c5,2);
	power(c11,c,11);
	power(c12,c6,2);
	power(c13,c,13);
	power(c14,c7,2);
	power(c15,c,15);
	power(c16,c8,2);
	power(c17,c,17);
	power(c18,c9,2);
	power(c19,c,19);
	power(c20,c10,2);
	power(c21,c7,3);
	power(c22,c11,2);
	power(c23,c,23);
	power(c24,c12,2);
	power(c25,c5,5);
	//--------------Final dels powers


    f.set_modulus( p );
    fz.set_modulus( p );


	// ---- Abcisas puntos P y Q
	
	
	gf_element x(F); //abcisa del punto P  
	gf_element u(F); //abcisa del punto Q  
	
	
	elliptic_curve<gf_element> E(1+c-c2,c2-c3,c2-c3,u,u);
	
	
	// -------- Final equacio de la corba
	
	bigint i,k;
	P.assign_zero(E);
	Q.assign_zero(E);
	
	// CASO CICLICO
	
	//if(segchi==-1)
	if(vqsol==false)
	{
	n=1;
	baixar(x,n);           
	P.set_x_coordinate(x); // la x ha de ser un gf_element
	}
	
	// CASO NO CÍCLICO

	else 
	{
	
	P.set_x_coordinate(x);
	u=segchi;
	n=1;
	baixar(x,n);
	r=1;
	baixar(u,r);
	if(n<r) { swap(n,r);swap(x,u);}
	Q.set_x_coordinate(u);
	do{
		i=0;
		k=n;
		P.set_x_coordinate(x);
		do {
			i=i+1;
			x=(P+i*Q).get_x();
			baixar(x,n);
		   }while(n==k && i<6);
	}while(n!=k);
	
	}
}		//ELSE DISCRIMINANT 0
}


int main() 

{
clock_t clock1,clock2;
clock1=clock();
cout<<"Inici del Programa -----"<<endl;
bigint p; cout<<"Introduim la P"<<endl;
cin>>p;

// Miniprogrameta per generar un numero primer congruent

//bigint aux(7919);
//p.randomize(aux);
//while(!p.is_prime() || (p%7)!=1) {p=p.next_prime();}
//cout<<p<<endl;

//

galois_field F(p);
gf_element c(F);cout<<"Introduim la C"<<endl; cin>>c;
bigint n,r;
point<gf_element> P,Q;
sylow(p,c,n,P,r,Q);
cout<< "La n i la r obtingudes (n,r) son :" "("<<n<<","<<r<<")"<<endl;
cout<<"Final del Programa -----"<<endl;

clock2 = clock();
double t = (double)(clock2-clock1)/CLOCKS_PER_SEC;
cout<<"El temps d'execucio es:"<<t<<endl;

return 0;
}

